<template>
    <div class="list-view">
        <page-title>
            <!-- <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button> -->
            <!-- <el-button
                @click="download"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData"
                class="filter-item"
            >
                导出
            </el-button> -->
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索昵称..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
            <!-- <el-radio-group v-model="reply" @change="getData">
                <el-radio-button label="">所有</el-radio-button>
                <el-radio-button :label="true">已回复</el-radio-button>
                <el-radio-button :label="false">未回复</el-radio-button>
            </el-radio-group> -->
            <el-radio-group v-model="status" @change="getData" style="margin-right: 10px">
                <el-radio-button label="">所有</el-radio-button>
                <el-radio-button v-for="item in statusOptions" :key="item.value" :label="item.value">
                    {{ item.label }}
                </el-radio-button>
            </el-radio-group>

            <el-input
                placeholder="搜索用户ID"
                v-model="userId"
                clearable
                class="filter-item"
                @keyup.enter.native="getData"
            >
            </el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="80"> </el-table-column>
            <el-table-column prop="userId" label="用户ID" width="80"> </el-table-column>
            <el-table-column prop="nickname" label="昵称"> </el-table-column>
            <!-- <el-table-column prop="phone" label="手机号" min-width="100"> </el-table-column> -->
            <el-table-column prop="createdAt" label="留言时间" min-width="140"> </el-table-column>
            <el-table-column prop="detail" label="详情" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="pic" label="图片" min-width="80">
                <template slot-scope="{ row }">
                    <span v-if="row.pic == ''">暂无<br />图片</span>
                    <el-image
                        v-else
                        style="width: 30px; height: 30px"
                        :src="row.pic[0]"
                        fit="cover"
                        :preview-src-list="row.pic"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="status" label="状态" min-width="80" :formatter="statusFormatter"> </el-table-column>
            <el-table-column prop="replyDetail" label="回复详情" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="repliedAt" label="回复时间" min-width="140"> </el-table-column>
            <el-table-column label="操作" align="right" fixed="right" width="210">
                <template slot-scope="{ row }">
                    <el-button
                        @click="changeRow(row, 'PROCESSING')"
                        type="success"
                        size="mini"
                        plain
                        v-if="row.status == 'REPLIED'"
                        >处理</el-button
                    >
                    <el-button
                        @click="changeRow(row, 'COMPLETED')"
                        type="success"
                        size="mini"
                        plain
                        v-else-if="row.status == 'PROCESSING'"
                        >完成</el-button
                    >
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'MessageList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/message/all',
            downloading: false,
            reply: false,
            statusOptions: [
                { label: '待反馈', value: 'NO_REPLY' },
                { label: '已反馈', value: 'REPLIED' },
                { label: '处理中', value: 'PROCESSING' },
                { label: '已完成', value: 'COMPLETED' }
            ],
            userId: '',
            status: 'NO_REPLY'
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                sort: 'id,desc',
                search: this.search,
                query: { del: false, status: this.status, userId: this.userId }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/messageEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/messageEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/message/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/message/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        changeRow(row, status) {
            this.$alert('确定修改状态吗？', '修改提示', { type: 'primary' })
                .then(() => {
                    return this.$http.post('/message/changeStatus', { id: row.id, status: status });
                })
                .then(() => {
                    this.$message.success('修改成功');
                    this.getData();
                })
                .catch(() => {});
        }
    }
};
</script>
<style lang="less" scoped></style>
